## lapack 3.12.1

=== Makefile ===
#
#  Top Level Makefile for LAPACK
#

TOPSRCDIR = .
include $(TOPSRCDIR)/make.inc

.PHONY: all
all: lapack_install lib blas_testing lapack_testing

.PHONY: lib
lib: lapacklib tmglib
#lib: blaslib variants lapacklib tmglib

.PHONY: blaslib
blaslib:
	$(MAKE) -C BLAS

.PHONY: cblaslib
cblaslib:
	$(MAKE) -C CBLAS

.PHONY: lapacklib
lapacklib:
	$(MAKE) -C SRC

.PHONY: lapackelib
lapackelib:
	$(MAKE) -C LAPACKE

.PHONY: blaspplib
blaspplib:
	@echo "Thank you for your interest in BLAS++, a newly developed C++ API for BLAS library"
	@echo "The objective of BLAS++ is to provide a convenient, performance oriented API for development in the C++ language, that, for the most part, preserves established conventions, while, at the same time, takes advantages of modern C++ features, such as: namespaces, templates, exceptions, etc."
	@echo "We are still working on integrating BLAS++ in our library. For the moment, you can download directly blas++ from https://bitbucket.org/icl/blaspp"
	@echo "For support BLAS++ related question, please email: slate-user@icl.utk.edu"

.PHONY: lapackpplib
lapackpplib:
	@echo "Thank you for your interest in LAPACK++, a newly developed C++ API for LAPACK library"
	@echo "The objective of LAPACK++ is to provide a convenient, performance oriented API for development in the C++ language, that, for the most part, preserves established conventions, while, at the same time, takes advantages of modern C++ features, such as: namespaces, templates, exceptions, etc."
	@echo "We are still working on integrating LAPACK++ in our library. For the moment, you can download directly lapack++ from https://bitbucket.org/icl/lapackpp"
	@echo "For support LAPACK++ related question, please email: slate-user@icl.utk.edu"

.PHONY: tmglib
tmglib:
	$(MAKE) -C TESTING/MATGEN

.PHONY: variants
variants:
	$(MAKE) -C SRC/VARIANTS

.PHONY: lapack_install
lapack_install:
	$(MAKE) -C INSTALL run

.PHONY: blas_testing
blas_testing: blaslib
	$(MAKE) -C BLAS blas_testing

.PHONY: cblas_testing
cblas_testing: cblaslib blaslib
	$(MAKE) -C CBLAS cblas_testing

.PHONY: lapack_testing
lapack_testing: tmglib lapacklib blaslib
	$(MAKE) -C TESTING/LIN cleanexe
	$(MAKE) -C TESTING
	./lapack_testing.py

.PHONY: variants_testing
variants_testing: tmglib variants lapacklib blaslib
	$(MAKE) -C TESTING/LIN cleanexe
	$(MAKE) -C TESTING/LIN VARLIB='../../SRC/VARIANTS/cholrl.a'
	$(MAKE) -C TESTING stest.out && mv TESTING/stest.out TESTING/stest_cholrl.out
	$(MAKE) -C TESTING dtest.out && mv TESTING/dtest.out TESTING/dtest_cholrl.out
	$(MAKE) -C TESTING ctest.out && mv TESTING/ctest.out TESTING/ctest_cholrl.out
	$(MAKE) -C TESTING ztest.out && mv TESTING/ztest.out TESTING/ztest_cholrl.out
	$(MAKE) -C TESTING/LIN cleanexe
	$(MAKE) -C TESTING/LIN VARLIB='../../SRC/VARIANTS/choltop.a'
	$(MAKE) -C TESTING stest.out && mv TESTING/stest.out TESTING/stest_choltop.out
	$(MAKE) -C TESTING dtest.out && mv TESTING/dtest.out TESTING/dtest_choltop.out
	$(MAKE) -C TESTING ctest.out && mv TESTING/ctest.out TESTING/ctest_choltop.out
	$(MAKE) -C TESTING ztest.out && mv TESTING/ztest.out TESTING/ztest_choltop.out
	$(MAKE) -C TESTING/LIN cleanexe
	$(MAKE) -C TESTING/LIN VARLIB='../../SRC/VARIANTS/lucr.a'
	$(MAKE) -C TESTING stest.out && mv TESTING/stest.out TESTING/stest_lucr.out
	$(MAKE) -C TESTING dtest.out && mv TESTING/dtest.out TESTING/dtest_lucr.out
	$(MAKE) -C TESTING ctest.out && mv TESTING/ctest.out TESTING/ctest_lucr.out
	$(MAKE) -C TESTING ztest.out && mv TESTING/ztest.out TESTING/ztest_lucr.out
	$(MAKE) -C TESTING/LIN cleanexe
	$(MAKE) -C TESTING/LIN VARLIB='../../SRC/VARIANTS/lull.a'
	$(MAKE) -C TESTING stest.out && mv TESTING/stest.out TESTING/stest_lull.out
	$(MAKE) -C TESTING dtest.out && mv TESTING/dtest.out TESTING/dtest_lull.out
	$(MAKE) -C TESTING ctest.out && mv TESTING/ctest.out TESTING/ctest_lull.out
	$(MAKE) -C TESTING ztest.out && mv TESTING/ztest.out TESTING/ztest_lull.out
	$(MAKE) -C TESTING/LIN cleanexe
	$(MAKE) -C TESTING/LIN VARLIB='../../SRC/VARIANTS/lurec.a'
	$(MAKE) -C TESTING stest.out && mv TESTING/stest.out TESTING/stest_lurec.out
	$(MAKE) -C TESTING dtest.out && mv TESTING/dtest.out TESTING/dtest_lurec.out
	$(MAKE) -C TESTING ctest.out && mv TESTING/ctest.out TESTING/ctest_lurec.out
	$(MAKE) -C TESTING ztest.out && mv TESTING/ztest.out TESTING/ztest_lurec.out
	$(MAKE) -C TESTING/LIN cleanexe
	$(MAKE) -C TESTING/LIN VARLIB='../../SRC/VARIANTS/qrll.a'
	$(MAKE) -C TESTING stest.out && mv TESTING/stest.out TESTING/stest_qrll.out
	$(MAKE) -C TESTING dtest.out && mv TESTING/dtest.out TESTING/dtest_qrll.out
	$(MAKE) -C TESTING ctest.out && mv TESTING/ctest.out TESTING/ctest_qrll.out
	$(MAKE) -C TESTING ztest.out && mv TESTING/ztest.out TESTING/ztest_qrll.out

.PHONY: cblas_example
cblas_example: cblaslib blaslib
	$(MAKE) -C CBLAS cblas_example

.PHONY: lapacke_example
lapacke_example: lapackelib lapacklib blaslib
	$(MAKE) -C LAPACKE lapacke_example

# doxygen 1.9.7 converts --- to &mdash; but than has a bug that
# encodes that as &amp;mdash; on some pages. Use perl to fix it.
.PHONY: html
html:
	@echo "LAPACK HTML page generation with Doxygen"
	(cat DOCS/Doxyfile; \
	    echo "OUTPUT_DIRECTORY=$(DOCSDIR)") | doxygen -
	grep '&amp;mdash' -r $(DOCSDIR)/explore-html -l | xargs perl -pi -e 's/&amp;mdash;/&mdash;/g'
	@echo "=================="
	@echo "LAPACK HTML pages generated in $(DOCSDIR)/explore-html"
	@echo "Usage: open $(DOCSDIR)/explore-html/index.html"
	@echo "Online version available at http://www.netlib.org/lapack/explore-html/"
	@echo "=================="

# Use same Doxyfile for man, and override the few options that change.
.PHONY: man
man:
	@echo "LAPACK man page generation with Doxygen"
	(cat DOCS/Doxyfile; \
	    echo "OUTPUT_DIRECTORY = $(DOCSDIR)"; \
	    echo "GENERATE_HTML    = NO"; \
	    echo "GENERATE_MAN     = YES"; \
	    echo "CALL_GRAPH       = NO"; \
	    echo "CALLER_GRAPH     = NO"; \
	    echo "INLINE_SOURCES   = NO") | doxygen -
	@echo "=================="
	@echo "LAPACK man pages generated in DOCS/man"
	@echo "Set your MANPATH env variable accordingly"
	@echo "Usage: man dgetrf"
	@echo "=================="

.PHONY: clean cleanobj cleanlib cleanexe cleantest
clean:
	$(MAKE) -C INSTALL clean
	$(MAKE) -C BLAS clean
	$(MAKE) -C CBLAS clean
	$(MAKE) -C SRC clean
	$(MAKE) -C SRC/VARIANTS clean
	$(MAKE) -C TESTING clean
	$(MAKE) -C TESTING/MATGEN clean
	$(MAKE) -C TESTING/LIN clean
	$(MAKE) -C TESTING/EIG clean
	$(MAKE) -C LAPACKE clean
	rm -f *.a
cleanobj:
	$(MAKE) -C INSTALL cleanobj
	$(MAKE) -C BLAS cleanobj
	$(MAKE) -C CBLAS cleanobj
	$(MAKE) -C SRC cleanobj
	$(MAKE) -C SRC/VARIANTS cleanobj
	$(MAKE) -C TESTING/MATGEN cleanobj
	$(MAKE) -C TESTING/LIN cleanobj
	$(MAKE) -C TESTING/EIG cleanobj
	$(MAKE) -C LAPACKE cleanobj
cleanlib:
	$(MAKE) -C BLAS cleanlib
	$(MAKE) -C CBLAS cleanlib
	$(MAKE) -C SRC cleanlib
	$(MAKE) -C SRC/VARIANTS cleanlib
	$(MAKE) -C TESTING/MATGEN cleanlib
	$(MAKE) -C LAPACKE cleanlib
	rm -f *.a
cleanexe:
	$(MAKE) -C INSTALL cleanexe
	$(MAKE) -C BLAS cleanexe
	$(MAKE) -C CBLAS cleanexe
	$(MAKE) -C TESTING/LIN cleanexe
	$(MAKE) -C TESTING/EIG cleanexe
	$(MAKE) -C LAPACKE cleanexe
cleantest:
	$(MAKE) -C INSTALL cleantest
	$(MAKE) -C BLAS cleantest
	$(MAKE) -C CBLAS cleantest
	$(MAKE) -C TESTING cleantest

=== BLAS/CMakeLists.txt ===
enable_language(Fortran)

# Check for any necessary platform specific compiler flags
include(CheckLAPACKCompilerFlags)
CheckLAPACKCompilerFlags()

add_subdirectory(SRC)
if(BUILD_TESTING)
  add_subdirectory(TESTING)
endif()
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/blas.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${BLASLIB}.pc @ONLY)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${BLASLIB}.pc
  DESTINATION ${PKG_CONFIG_DIR}
  COMPONENT Development
  )

=== CBLAS/Makefile ===
TOPSRCDIR = ..
include $(TOPSRCDIR)/make.inc

.PHONY: all
all: cblas

.PHONY: cblas
cblas: include/cblas_mangling.h
	$(MAKE) -C src

include/cblas_mangling.h: include/cblas_mangling_with_flags.h.in
	cp include/cblas_mangling_with_flags.h.in $@

.PHONY: cblas_testing
cblas_testing: cblas
	$(MAKE) -C testing run

.PHONY: cblas_example
cblas_example: cblas
	$(MAKE) -C examples

.PHONY: clean cleanobj cleanlib cleanexe cleantest
clean:
	$(MAKE) -C src clean
	$(MAKE) -C testing clean
	$(MAKE) -C examples clean
cleanobj:
	$(MAKE) -C src cleanobj
	$(MAKE) -C testing cleanobj
	$(MAKE) -C examples cleanobj
cleanlib:
	$(MAKE) -C src cleanlib
cleanexe:
	$(MAKE) -C testing cleanexe
	$(MAKE) -C examples cleanexe
cleantest:
	$(MAKE) -C testing cleantest

=== LAPACKE/CMakeLists.txt ===
message(STATUS "LAPACKE enabled")
enable_language(C)

set(LAPACK_INSTALL_EXPORT_NAME ${LAPACKELIB}-targets)

include_directories(include ${LAPACK_BINARY_DIR}/include)
add_subdirectory(src)
add_subdirectory(utils)

option(LAPACKE_BUILD_SINGLE "Build LAPACKE single precision real" ON)
option(LAPACKE_BUILD_DOUBLE "Build LAPACKE double precision real" ON)
option(LAPACKE_BUILD_COMPLEX "Build LAPACKE single precision complex" ON)
option(LAPACKE_BUILD_COMPLEX16 "Build LAPACKE double precision complex" ON)

foreach(precision SINGLE DOUBLE COMPLEX COMPLEX16)
  if(LAPACKE_BUILD_${precision} AND NOT BUILD_${precision})
    message(
      SEND_ERROR
      "LAPACKE_BUILD_${precision} requires BUILD_${precision} to be ON"
    )
  endif()
endforeach()

macro(append_subdir_files variable dirname)
  get_directory_property(holder DIRECTORY ${dirname} DEFINITION ${variable})
  foreach(depfile ${holder})
    list(APPEND ${variable} "${dirname}/${depfile}")
  endforeach()
endmacro()

message(STATUS "Build LAPACKE single precision real: ${LAPACKE_BUILD_SINGLE}")
message(STATUS "Build LAPACKE double precision real: ${LAPACKE_BUILD_DOUBLE}")
message(STATUS "Build LAPACKE single precision complex: ${LAPACKE_BUILD_COMPLEX}")
message(STATUS "Build LAPACKE double precision complex: ${LAPACKE_BUILD_COMPLEX16}")

append_subdir_files(LAPACKE_INCLUDE "include")
append_subdir_files(SOURCES "src")
if (LAPACKE_BUILD_SINGLE)
  append_subdir_files(SOURCES_SINGLE "src")
  list(APPEND SOURCES ${SOURCES_SINGLE})
endif()
if (LAPACKE_BUILD_DOUBLE)
  append_subdir_files(SOURCES_DOUBLE "src")
  list(APPEND SOURCES ${SOURCES_DOUBLE})
endif()
if (LAPACKE_BUILD_COMPLEX)
  append_subdir_files(SOURCES_COMPLEX "src")
  list(APPEND SOURCES ${SOURCES_COMPLEX})
endif()
if (LAPACKE_BUILD_COMPLEX16)
  append_subdir_files(SOURCES_COMPLEX16 "src")
  list(APPEND SOURCES ${SOURCES_COMPLEX16})
endif()
append_subdir_files(DEPRECATED "src")
append_subdir_files(EXTENDED "src")
append_subdir_files(MATGEN "src")
append_subdir_files(UTILS "utils")

if(BUILD_DEPRECATED)
  list(APPEND SOURCES ${DEPRECATED})
endif()
if(USE_XBLAS)
  list(APPEND SOURCES ${EXTENDED})
endif()
if(LAPACKE_WITH_TMG)
  list(APPEND SOURCES ${MATGEN})
endif()
list(APPEND SOURCES ${UTILS})

add_library(${LAPACKELIB}_obj OBJECT ${SOURCES})
set_target_properties(${LAPACKELIB}_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)

if(BUILD_INDEX64_EXT_API)
  # 64bit Integer Extended Interface
  set(SOURCES_64_C)
  list(APPEND SOURCES_64_C ${SOURCES})
  list(REMOVE_ITEM SOURCES_64_C src/lapacke_nancheck.c)
  list(REMOVE_ITEM SOURCES_64_C utils/lapacke_make_complex_float.c)
  list(REMOVE_ITEM SOURCES_64_C utils/lapacke_make_complex_double.c)
  add_library(${LAPACKELIB}_64_obj OBJECT ${SOURCES_64_C})
  set_target_properties(${LAPACKELIB}_64_obj PROPERTIES
          POSITION_INDEPENDENT_CODE ON)
  target_compile_options(${LAPACKELIB}_64_obj PRIVATE
          -DLAPACK_ILP64
          -DLAPACKE_API64
          -DWeirdNEC
          -DCBLAS_API64)
endif()

add_library(${LAPACKELIB} $<TARGET_OBJECTS:${LAPACKELIB}_obj>
        $<$<BOOL:${BUILD_INDEX64_EXT_API}>: $<TARGET_OBJECTS:${LAPACKELIB}_64_obj>>)

set_target_properties(
  ${LAPACKELIB} PROPERTIES
  LINKER_LANGUAGE C
  VERSION ${LAPACK_VERSION}
  SOVERSION ${LAPACK_MAJOR_VERSION}
  POSITION_INDEPENDENT_CODE ON
  )
target_include_directories(${LAPACKELIB} PUBLIC
    $<BUILD_INTERFACE:${LAPACK_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
if(WIN32 AND NOT UNIX)
  target_compile_definitions(${LAPACKELIB} PUBLIC HAVE_LAPACK_CONFIG_H LAPACK_COMPLEX_STRUCTURE)
  message(STATUS "Windows BUILD")
endif()

if(LAPACKE_WITH_TMG)
  target_link_libraries(${LAPACKELIB} PRIVATE ${TMGLIB})
endif()
target_link_libraries(${LAPACKELIB} PRIVATE ${LAPACK_LIBRARIES})

lapack_install_library(${LAPACKELIB})
install(
  FILES ${LAPACKE_INCLUDE} ${LAPACK_BINARY_DIR}/include/lapacke_mangling.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  COMPONENT Development
  )

if(BUILD_TESTING)
  add_subdirectory(example)
endif()


configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lapacke.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${LAPACKELIB}.pc @ONLY)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${LAPACKELIB}.pc
  DESTINATION ${PKG_CONFIG_DIR}
  COMPONENT Development
  )

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/lapacke-config-version.cmake.in
  ${LAPACK_BINARY_DIR}/${LAPACKELIB}-config-version.cmake @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/lapacke-config-build.cmake.in
  ${LAPACK_BINARY_DIR}/${LAPACKELIB}-config.cmake @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/lapacke-config-install.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/${LAPACKELIB}-config.cmake @ONLY)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/${LAPACKELIB}-config.cmake
  ${LAPACK_BINARY_DIR}/${LAPACKELIB}-config-version.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${LAPACKELIB}-${LAPACK_VERSION}
  COMPONENT Development
  )

install(EXPORT ${LAPACKELIB}-targets
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${LAPACKELIB}-${LAPACK_VERSION}
  COMPONENT Development
  )

=== TESTING/CMakeLists.txt ===
enable_language(Fortran)

# Check for any necessary platform specific compiler flags
include(CheckLAPACKCompilerFlags)
CheckLAPACKCompilerFlags()

if(MSVC_VERSION)
#  string(REPLACE "/STACK:10000000" "/STACK:900000000000000000"
#    CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
  string(REGEX REPLACE "(.*)/STACK:(.*) (.*)" "\\1/STACK:900000000000000000 \\3"
    CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
endif()
add_subdirectory(LIN)
add_subdirectory(EIG)


# Only run this test if python 3 is found
if(PYTHON_EXECUTABLE AND LAPACK_TESTING_USE_PYTHON)
  message(STATUS "Enabling LAPACK test summary (see TESTING/testing_results.txt)")
  file(COPY ${LAPACK_SOURCE_DIR}/lapack_testing.py DESTINATION ${LAPACK_BINARY_DIR})
  add_test(
    NAME LAPACK_Test_Summary
    WORKING_DIRECTORY ${LAPACK_BINARY_DIR}
    COMMAND ${PYTHON_EXECUTABLE} "lapack_testing.py"
    )
endif()

function(add_lapack_test output input target)
  set(TEST_INPUT "${LAPACK_SOURCE_DIR}/TESTING/${input}")
  set(TEST_OUTPUT "${LAPACK_BINARY_DIR}/TESTING/${output}")
  string(REPLACE "." "_" input_name ${input})
  set(testName "${target}_${input_name}")
  if(EXISTS "${TEST_INPUT}")
    add_test(NAME LAPACK-${testName} COMMAND "${CMAKE_COMMAND}"
      -DTEST=$<TARGET_FILE:${target}>
      -DINPUT=${TEST_INPUT}
      -DOUTPUT=${TEST_OUTPUT}
      -DINTDIR=${CMAKE_CFG_INTDIR}
      -P "${LAPACK_SOURCE_DIR}/TESTING/runtest.cmake")

    if(PYTHON_EXECUTABLE AND LAPACK_TESTING_USE_PYTHON)
      set_property(
        TEST LAPACK_Test_Summary
        APPEND PROPERTY DEPENDS LAPACK-${testName}
      )
    endif()
  endif()
endfunction()

if(BUILD_SINGLE)
add_lapack_test(stest.out stest.in xlintsts)
#
# ======== SINGLE RFP LIN TESTS ========================
add_lapack_test(stest_rfp.out stest_rfp.in xlintstrfs)
#
# ======== SINGLE EIG TESTS ===========================
add_lapack_test(snep.out nep.in xeigtsts)
add_lapack_test(ssep.out sep.in xeigtsts)
add_lapack_test(sse2.out se2.in xeigtsts)
add_lapack_test(ssvd.out svd.in xeigtsts)
add_lapack_test(sec.out sec.in xeigtsts)
add_lapack_test(sed.out sed.in xeigtsts)
add_lapack_test(sgg.out sgg.in xeigtsts)
add_lapack_test(sgd.out sgd.in xeigtsts)
add_lapack_test(ssb.out ssb.in xeigtsts)
add_lapack_test(ssg.out ssg.in xeigtsts)
add_lapack_test(sbal.out sbal.in xeigtsts)
add_lapack_test(sbak.out sbak.in xeigtsts)
add_lapack_test(sgbal.out sgbal.in xeigtsts)
add_lapack_test(sgbak.out sgbak.in xeigtsts)
add_lapack_test(sbb.out sbb.in xeigtsts)
add_lapack_test(sglm.out glm.in xeigtsts)
add_lapack_test(sgqr.out gqr.in xeigtsts)
add_lapack_test(sgsv.out gsv.in xeigtsts)
add_lapack_test(scsd.out csd.in xeigtsts)
add_lapack_test(slse.out lse.in xeigtsts)
#
# ======== SINGLE DMD EIG TESTS ===========================
add_lapack_test(sdmd.out sdmd.in xdmdeigtsts)
endif()

if(BUILD_DOUBLE)
#
# ======== DOUBLE LIN TESTS ===========================
add_lapack_test(dtest.out dtest.in xlintstd)
#
# ======== DOUBLE RFP LIN TESTS ========================
add_lapack_test(dtest_rfp.out dtest_rfp.in xlintstrfd)
#
# ======== DOUBLE EIG TESTS ===========================
add_lapack_test(dnep.out nep.in xeigtstd)
add_lapack_test(dsep.out sep.in xeigtstd)
add_lapack_test(dse2.out se2.in xeigtstd)
add_lapack_test(dsvd.out svd.in xeigtstd)
add_lapack_test(dec.out dec.in xeigtstd)
add_lapack_test(ded.out ded.in xeigtstd)
add_lapack_test(dgg.out dgg.in xeigtstd)
add_lapack_test(dgd.out dgd.in xeigtstd)
add_lapack_test(dsb.out dsb.in xeigtstd)
add_lapack_test(dsg.out dsg.in xeigtstd)
add_lapack_test(dbal.out dbal.in xeigtstd)
add_lapack_test(dbak.out dbak.in xeigtstd)
add_lapack_test(dgbal.out dgbal.in xeigtstd)
add_lapack_test(dgbak.out dgbak.in xeigtstd)
add_lapack_test(dbb.out dbb.in xeigtstd)
add_lapack_test(dglm.out glm.in xeigtstd)
add_lapack_test(dgqr.out gqr.in xeigtstd)
add_lapack_test(dgsv.out gsv.in xeigtstd)
add_lapack_test(dcsd.out csd.in xeigtstd)
add_lapack_test(dlse.out lse.in xeigtstd)
#
# ======== DOUBLE DMD EIG TESTS ===========================
add_lapack_test(ddmd.out ddmd.in xdmdeigtstd)
endif()

if(BUILD_COMPLEX)
add_lapack_test(ctest.out ctest.in xlintstc)
#
# ======== COMPLEX RFP LIN TESTS ========================
add_lapack_test(ctest_rfp.out ctest_rfp.in xlintstrfc)
#
# ======== COMPLEX EIG TESTS ===========================
add_lapack_test(cnep.out nep.in xeigtstc)
add_lapack_test(csep.out sep.in xeigtstc)
add_lapack_test(cse2.out se2.in xeigtstc)
add_lapack_test(csvd.out svd.in xeigtstc)
add_lapack_test(cec.out cec.in xeigtstc)
add_lapack_test(ced.out ced.in xeigtstc)
add_lapack_test(cgg.out cgg.in xeigtstc)
add_lapack_test(cgd.out cgd.in xeigtstc)
add_lapack_test(csb.out csb.in xeigtstc)
add_lapack_test(csg.out csg.in xeigtstc)
add_lapack_test(cbal.out cbal.in xeigtstc)
add_lapack_test(cbak.out cbak.in xeigtstc)
add_lapack_test(cgbal.out cgbal.in xeigtstc)
add_lapack_test(cgbak.out cgbak.in xeigtstc)
add_lapack_test(cbb.out cbb.in xeigtstc)
add_lapack_test(cglm.out glm.in xeigtstc)
add_lapack_test(cgqr.out gqr.in xeigtstc)
add_lapack_test(cgsv.out gsv.in xeigtstc)
add_lapack_test(ccsd.out csd.in xeigtstc)
add_lapack_test(clse.out lse.in xeigtstc)
#
# ======== COMPLEX DMD EIG TESTS ===========================
add_lapack_test(cdmd.out cdmd.in xdmdeigtstc)
endif()

if(BUILD_COMPLEX16)
#
# ======== COMPLEX16 LIN TESTS ========================
add_lapack_test(ztest.out ztest.in xlintstz)
#
# ======== COMPLEX16 RFP LIN TESTS ========================
add_lapack_test(ztest_rfp.out ztest_rfp.in xlintstrfz)
#
# ======== COMPLEX16 EIG TESTS ===========================
add_lapack_test(znep.out nep.in xeigtstz)
add_lapack_test(zsep.out sep.in xeigtstz)
add_lapack_test(zse2.out se2.in xeigtstz)
add_lapack_test(zsvd.out svd.in xeigtstz)
add_lapack_test(zec.out zec.in xeigtstz)
add_lapack_test(zed.out zed.in xeigtstz)
add_lapack_test(zgg.out zgg.in xeigtstz)
add_lapack_test(zgd.out zgd.in xeigtstz)
add_lapack_test(zsb.out zsb.in xeigtstz)
add_lapack_test(zsg.out zsg.in xeigtstz)
add_lapack_test(zbal.out zbal.in xeigtstz)
add_lapack_test(zbak.out zbak.in xeigtstz)
add_lapack_test(zgbal.out zgbal.in xeigtstz)
add_lapack_test(zgbak.out zgbak.in xeigtstz)
add_lapack_test(zbb.out zbb.in xeigtstz)
add_lapack_test(zglm.out glm.in xeigtstz)
add_lapack_test(zgqr.out gqr.in xeigtstz)
add_lapack_test(zgsv.out gsv.in xeigtstz)
add_lapack_test(zcsd.out csd.in xeigtstz)
add_lapack_test(zlse.out lse.in xeigtstz)
#
# ======== COMPLEX16 DMD EIG TESTS ===========================
add_lapack_test(zdmd.out zdmd.in xdmdeigtstz)
endif()


if(BUILD_SINGLE AND BUILD_DOUBLE)
#
# ======== SINGLE-DOUBLE PROTO LIN TESTS ==============
  add_lapack_test(dstest.out dstest.in xlintstds)
endif()


if(BUILD_COMPLEX AND BUILD_COMPLEX16)
#
# ======== COMPLEX-COMPLEX16 LIN TESTS ========================
  add_lapack_test(zctest.out zctest.in xlintstzc)
endif()

=== BLAS/SRC/Makefile ===
#######################################################################
#  This is the makefile to create a library for the BLAS.
#  The files are grouped as follows:
#
#       SBLAS1 -- Single precision real BLAS routines
#       CBLAS1 -- Single precision complex BLAS routines
#       DBLAS1 -- Double precision real BLAS routines
#       ZBLAS1 -- Double precision complex BLAS routines
#
#       CB1AUX -- Real BLAS routines called by complex routines
#       ZB1AUX -- D.P. real BLAS routines called by d.p. complex
#                 routines
#
#      ALLBLAS -- Auxiliary routines for Level 2 and 3 BLAS
#
#       SBLAS2 -- Single precision real BLAS2 routines
#       CBLAS2 -- Single precision complex BLAS2 routines
#       DBLAS2 -- Double precision real BLAS2 routines
#       ZBLAS2 -- Double precision complex BLAS2 routines
#
#       SBLAS3 -- Single precision real BLAS3 routines
#       CBLAS3 -- Single precision complex BLAS3 routines
#       DBLAS3 -- Double precision real BLAS3 routines
#       ZBLAS3 -- Double precision complex BLAS3 routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Note that these commands are not safe for parallel builds.
#
#  Alternatively, the commands
#       make all
#  or
#       make
#  without any arguments creates a library of all four precisions.
#  The name of the library is held in BLASLIB, which is set in the
#  top-level make.inc
#
#  To remove the object files after the library is created, enter
#       make cleanobj
#  To force the source files to be recompiled, enter, for example,
#       make single FRC=FRC
#
#---------------------------------------------------------------------
#
#  Edward Anderson, University of Tennessee
#  March 26, 1990
#  Susan Ostrouchov, Last updated September 30, 1994
#  ejr, May 2006.
#
#######################################################################

TOPSRCDIR = ../..
include $(TOPSRCDIR)/make.inc

.SUFFIXES: .F .f90 .o
.F.o:
	$(FC) $(FFLAGS) -c -o $@ $<
.f90.o:
	$(FC) $(FFLAGS) -c -o $@ $<

.PHONY: all
all: $(BLASLIB)

#---------------------------------------------------------
#  Comment out the next 6 definitions if you already have
#  the Level 1 BLAS.
#---------------------------------------------------------
SBLAS1 = isamax.o sasum.o saxpy.o scopy.o sdot.o snrm2.o \
	srot.o srotg.o sscal.o sswap.o sdsdot.o srotmg.o srotm.o
$(SBLAS1): $(FRC)

CBLAS1 = scabs1.o scasum.o scnrm2.o icamax.o caxpy.o ccopy.o \
	cdotc.o cdotu.o csscal.o crotg.o cscal.o cswap.o csrot.o
$(CBLAS1): $(FRC)

DBLAS1 = idamax.o dasum.o daxpy.o dcopy.o ddot.o dnrm2.o \
	drot.o drotg.o dscal.o dsdot.o dswap.o drotmg.o drotm.o
$(DBLAS1): $(FRC)

ZBLAS1 = dcabs1.o dzasum.o dznrm2.o izamax.o zaxpy.o zcopy.o \
	zdotc.o zdotu.o zdscal.o zrotg.o zscal.o zswap.o zdrot.o
$(ZBLAS1): $(FRC)

CB1AUX = isamax.o sasum.o saxpy.o scopy.o snrm2.o sscal.o
$(CB1AUX): $(FRC)

ZB1AUX = idamax.o dasum.o daxpy.o dcopy.o dnrm2.o dscal.o
$(ZB1AUX): $(FRC)

#---------------------------------------------------------------------
#  The following line defines auxiliary routines needed by both the
#  Level 2 and Level 3 BLAS.  Comment it out only if you already have
#  both the Level 2 and 3 BLAS.
#---------------------------------------------------------------------
ALLBLAS = lsame.o xerbla.o xerbla_array.o
$(ALLBLAS): $(FRC)

#---------------------------------------------------------
#  Comment out the next 4 definitions if you already have
#  the Level 2 BLAS.
#---------------------------------------------------------
SBLAS2 = sgemv.o sgbmv.o ssymv.o ssbmv.o sspmv.o \
	strmv.o stbmv.o stpmv.o strsv.o stbsv.o stpsv.o \
	sger.o ssyr.o sspr.o ssyr2.o sspr2.o
$(SBLAS2): $(FRC)

CBLAS2 = cgemv.o cgbmv.o chemv.o chbmv.o chpmv.o \
	ctrmv.o ctbmv.o ctpmv.o ctrsv.o ctbsv.o ctpsv.o \
	cgerc.o cgeru.o cher.o chpr.o cher2.o chpr2.o
$(CBLAS2): $(FRC)

DBLAS2 = dgemv.o dgbmv.o dsymv.o dsbmv.o dspmv.o \
	dtrmv.o dtbmv.o dtpmv.o dtrsv.o dtbsv.o dtpsv.o \
	dger.o dsyr.o dspr.o dsyr2.o dspr2.o
$(DBLAS2): $(FRC)

ZBLAS2 = zgemv.o zgbmv.o zhemv.o zhbmv.o zhpmv.o \
	ztrmv.o ztbmv.o ztpmv.o ztrsv.o ztbsv.o ztpsv.o \
	zgerc.o zgeru.o zher.o zhpr.o zher2.o zhpr2.o
$(ZBLAS2): $(FRC)

#---------------------------------------------------------
#  Comment out the next 4 definitions if you already have
#  the Level 3 BLAS.
#---------------------------------------------------------
SBLAS3 = sgemm.o ssymm.o ssyrk.o ssyr2k.o strmm.o strsm.o sgemmtr.o
$(SBLAS3): $(FRC)

CBLAS3 = cgemm.o csymm.o csyrk.o csyr2k.o ctrmm.o ctrsm.o \
	chemm.o cherk.o cher2k.o cgemmtr.o
$(CBLAS3): $(FRC)

DBLAS3 = dgemm.o dsymm.o dsyrk.o dsyr2k.o dtrmm.o dtrsm.o dgemmtr.o
$(DBLAS3): $(FRC)

ZBLAS3 = zgemm.o zsymm.o zsyrk.o zsyr2k.o ztrmm.o ztrsm.o \
	zhemm.o zherk.o zher2k.o zgemmtr.o
$(ZBLAS3): $(FRC)

ALLOBJ = $(SBLAS1) $(SBLAS2) $(SBLAS3) $(DBLAS1) $(DBLAS2) $(DBLAS3) \
	$(CBLAS1) $(CBLAS2) $(CBLAS3) $(ZBLAS1) \
	$(ZBLAS2) $(ZBLAS3) $(ALLBLAS)

$(BLASLIB): $(ALLOBJ)
	$(AR) $(ARFLAGS) $@ $^
	$(RANLIB) $@

.PHONY: single double complex complex16
single: $(SBLAS1) $(ALLBLAS) $(SBLAS2) $(SBLAS3)
	$(AR) $(ARFLAGS) $(BLASLIB) $^
	$(RANLIB) $(BLASLIB)

double: $(DBLAS1) $(ALLBLAS) $(DBLAS2) $(DBLAS3)
	$(AR) $(ARFLAGS) $(BLASLIB) $^
	$(RANLIB) $(BLASLIB)

complex: $(CBLAS1) $(CB1AUX) $(ALLBLAS) $(CBLAS2) $(CBLAS3)
	$(AR) $(ARFLAGS) $(BLASLIB) $^
	$(RANLIB) $(BLASLIB)

complex16: $(ZBLAS1) $(ZB1AUX) $(ALLBLAS) $(ZBLAS2) $(ZBLAS3)
	$(AR) $(ARFLAGS) $(BLASLIB) $^
	$(RANLIB) $(BLASLIB)

FRC:
	@FRC=$(FRC)

.PHONY: clean cleanobj cleanlib
clean: cleanobj cleanlib
cleanobj:
	rm -f *.o
cleanlib:
	#rm -f $(BLASLIB)  # May point to a system lib, e.g. -lblas

=== CBLAS/src/CMakeLists.txt ===
# This Makefile compiles the CBLAS routines

# Error handling routines for level 2 & 3
set(ERRHAND cblas_globals.c cblas_xerbla.c xerbla.c)

#
#
# CBLAS routines
#
# Level 1
#
#

# Files for level 1 single precision real
set(SLEV1 cblas_srotg.c cblas_srotmg.c cblas_srot.c cblas_srotm.c
         cblas_sswap.c cblas_sscal.c  cblas_scopy.c cblas_saxpy.c
         cblas_sdot.c  cblas_sdsdot.c cblas_snrm2.c cblas_sasum.c
         cblas_isamax.c sdotsub.f sdsdotsub.f snrm2sub.f sasumsub.f
         isamaxsub.f)

# Files for level 1 double precision real
set(DLEV1 cblas_drotg.c cblas_drotmg.c cblas_drot.c cblas_drotm.c
         cblas_dswap.c cblas_dscal.c  cblas_dcopy.c cblas_daxpy.c
         cblas_ddot.c  cblas_dsdot.c cblas_dnrm2.c cblas_dasum.c
         cblas_idamax.c ddotsub.f dsdotsub.f dnrm2sub.f
         dasumsub.f idamaxsub.f)

# Files for level 1 single precision complex
set(CLEV1 cblas_crotg.c cblas_csrot.c
         cblas_cswap.c cblas_cscal.c cblas_csscal.c cblas_ccopy.c
         cblas_caxpy.c cblas_cdotu_sub.c cblas_cdotc_sub.c
         cblas_icamax.c cdotcsub.f cdotusub.f icamaxsub.f
         cblas_scabs1.c scabs1sub.f )

# Files for level 1 double precision complex
set(ZLEV1 cblas_zrotg.c cblas_zdrot.c
         cblas_zswap.c cblas_zscal.c cblas_zdscal.c cblas_zcopy.c
         cblas_zaxpy.c cblas_zdotu_sub.c cblas_zdotc_sub.c cblas_dznrm2.c
         cblas_dzasum.c cblas_izamax.c zdotcsub.f zdotusub.f
         dzasumsub.f dznrm2sub.f izamaxsub.f
         cblas_dcabs1.c dcabs1sub.f)

# Common files for level 1 single precision
set(SCLEV1 cblas_scasum.c scasumsub.f cblas_scnrm2.c scnrm2sub.f)

#
#
# CBLAS routines
#
# Level 2
#
#

# Files for level 2 single precision real
set(SLEV2 cblas_sgemv.c cblas_sgbmv.c cblas_sger.c  cblas_ssbmv.c cblas_sspmv.c
        cblas_sspr.c  cblas_sspr2.c cblas_ssymv.c cblas_ssyr.c  cblas_ssyr2.c
        cblas_stbmv.c cblas_stbsv.c cblas_stpmv.c cblas_stpsv.c cblas_strmv.c
        cblas_strsv.c)

# Files for level 2 double precision real
set(DLEV2 cblas_dgemv.c cblas_dgbmv.c cblas_dger.c  cblas_dsbmv.c cblas_dspmv.c
        cblas_dspr.c  cblas_dspr2.c cblas_dsymv.c cblas_dsyr.c  cblas_dsyr2.c
        cblas_dtbmv.c cblas_dtbsv.c cblas_dtpmv.c cblas_dtpsv.c cblas_dtrmv.c
        cblas_dtrsv.c)

# Files for level 2 single precision complex
set(CLEV2 cblas_cgemv.c cblas_cgbmv.c cblas_chemv.c cblas_chbmv.c cblas_chpmv.c
        cblas_ctrmv.c cblas_ctbmv.c cblas_ctpmv.c cblas_ctrsv.c cblas_ctbsv.c
        cblas_ctpsv.c cblas_cgeru.c cblas_cgerc.c cblas_cher.c  cblas_cher2.c
        cblas_chpr.c  cblas_chpr2.c)

# Files for level 2 double precision complex
set(ZLEV2 cblas_zgemv.c cblas_zgbmv.c cblas_zhemv.c cblas_zhbmv.c cblas_zhpmv.c
        cblas_ztrmv.c cblas_ztbmv.c cblas_ztpmv.c cblas_ztrsv.c cblas_ztbsv.c
        cblas_ztpsv.c cblas_zgeru.c cblas_zgerc.c cblas_zher.c  cblas_zher2.c
        cblas_zhpr.c  cblas_zhpr2.c)

#
#
# CBLAS routines
#
# Level 3
#
#

# Files for level 3 single precision real
set(SLEV3 cblas_sgemm.c cblas_ssymm.c cblas_ssyrk.c cblas_ssyr2k.c cblas_strmm.c
        cblas_strsm.c cblas_sgemmtr.c)

# Files for level 3 double precision real
set(DLEV3 cblas_dgemm.c cblas_dsymm.c cblas_dsyrk.c cblas_dsyr2k.c cblas_dtrmm.c
        cblas_dtrsm.c cblas_dgemmtr.c)

# Files for level 3 single precision complex
set(CLEV3 cblas_cgemm.c cblas_csymm.c cblas_chemm.c cblas_cherk.c
        cblas_cher2k.c cblas_ctrmm.c cblas_ctrsm.c cblas_csyrk.c
        cblas_csyr2k.c cblas_cgemmtr.c)

# Files for level 3 double precision complex
set(ZLEV3 cblas_zgemm.c cblas_zsymm.c cblas_zhemm.c cblas_zherk.c
        cblas_zher2k.c cblas_ztrmm.c cblas_ztrsm.c cblas_zsyrk.c
        cblas_zsyr2k.c cblas_zgemmtr.c)


set(SOURCES)
if(BUILD_SINGLE)
  list(APPEND SOURCES ${SLEV1} ${SCLEV1} ${SLEV2} ${SLEV3} ${ERRHAND})
endif()
if(BUILD_DOUBLE)
  list(APPEND SOURCES ${DLEV1} ${DLEV2} ${DLEV3} ${ERRHAND})
endif()
if(BUILD_COMPLEX)
  list(APPEND SOURCES ${CLEV1} ${SCLEV1} ${CLEV2} ${CLEV3} ${ERRHAND})
endif()
if(BUILD_COMPLEX16)
  list(APPEND SOURCES ${ZLEV1} ${ZLEV2} ${ZLEV3} ${ERRHAND})
endif()
list(REMOVE_DUPLICATES SOURCES)

add_library(${CBLASLIB}_obj OBJECT ${SOURCES})
set_target_properties(${CBLASLIB}_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
if(HAS_ATTRIBUTE_WEAK_SUPPORT)
  target_compile_definitions(${CBLASLIB}_obj PRIVATE HAS_ATTRIBUTE_WEAK_SUPPORT)
endif()

if(BUILD_INDEX64_EXT_API)
  # 64bit Integer Interface
  # Define list of C files
  set(SOURCES_64_C)
  list(APPEND SOURCES_64_C ${SOURCES})
  list(FILTER SOURCES_64_C  EXCLUDE REGEX "\.f$")
  list(REMOVE_ITEM SOURCES_64_C cblas_globals.c)
  # Define list of Fortran files
  set(SOURCES_64_F)
  list(APPEND SOURCES_64_F ${SOURCES})
  list(FILTER SOURCES_64_F  INCLUDE REGEX "\.f$")
  # Copy files so we can set source property specific to /${CBLASLIB}_64_obj target
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${CBLASLIB}_64_fobj)
  file(COPY ${SOURCES_64_F} DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/${CBLASLIB}_64_fobj)
  file(GLOB SOURCES_64_F ${CMAKE_CURRENT_BINARY_DIR}/${CBLASLIB}_64_fobj/*)
  add_library(${CBLASLIB}_64_cobj OBJECT ${SOURCES_64_C})
  add_library(${CBLASLIB}_64_fobj OBJECT ${SOURCES_64_F})
  set_target_properties(${CBLASLIB}_64_cobj ${CBLASLIB}_64_fobj PROPERTIES
          POSITION_INDEPENDENT_CODE ON
          Fortran_PREPROCESS ON
          LINKER_LANGUAGE C)
  target_compile_options(${CBLASLIB}_64_cobj PRIVATE -DWeirdNEC -DCBLAS_API64)
  target_compile_options(${CBLASLIB}_64_fobj PRIVATE ${FOPT_ILP64})
  if(HAS_ATTRIBUTE_WEAK_SUPPORT)
    target_compile_definitions(${CBLASLIB}_64_cobj PRIVATE HAS_ATTRIBUTE_WEAK_SUPPORT)
  endif()
  #Add suffix to all Fortran functions via macros
  foreach(F IN LISTS SOURCES_64_F)
      set(COPT_64_F)
      file(STRINGS ${F} ${F}.lst)
      list(FILTER ${F}.lst INCLUDE REGEX "subroutine|external")
      foreach(FUNC IN LISTS ${F}.lst)
        string(REGEX REPLACE "[ ]*(subroutine|external)[ ]*" "" FUNC ${FUNC})
        string(REGEX REPLACE "[(][a-zA-Z0-9, ]*[)]" "" FUNC ${FUNC})
        list(APPEND COPT_64_F "-D${FUNC}=${FUNC}_64")
      endforeach()
      set_source_files_properties(${F} PROPERTIES COMPILE_OPTIONS "${COPT_64_F}")
  endforeach()
endif()

add_library(${CBLASLIB}
        $<TARGET_OBJECTS:${CBLASLIB}_obj>
        $<$<BOOL:${BUILD_INDEX64_EXT_API}>: $<TARGET_OBJECTS:${CBLASLIB}_64_cobj>>
        $<$<BOOL:${BUILD_INDEX64_EXT_API}>: $<TARGET_OBJECTS:${CBLASLIB}_64_fobj>>)

set_target_properties(
  ${CBLASLIB} PROPERTIES
  LINKER_LANGUAGE C
  VERSION ${LAPACK_VERSION}
  SOVERSION ${LAPACK_MAJOR_VERSION}
  POSITION_INDEPENDENT_CODE ON
  )

target_include_directories(${CBLASLIB} PUBLIC
  $<INSTALL_INTERFACE:include>
)
target_link_libraries(${CBLASLIB} PUBLIC ${BLAS_LIBRARIES})
lapack_install_library(${CBLASLIB})

=== CBLAS/src/Makefile ===
# This Makefile compiles the CBLAS routines

TOPSRCDIR = ../..
include $(TOPSRCDIR)/make.inc

.SUFFIXES: .c .o
.c.o:
	$(CC) $(CFLAGS) -I../include -c -o $@ $<

.PHONY: all
all: $(CBLASLIB)

# Error handling routines for level 2 & 3
errhand = cblas_globals.o cblas_xerbla.o xerbla.o

#
#
# CBLAS routines
#
# Level 1
#
#

# Files for level 1 single precision real
slev1 = cblas_srotg.o cblas_srotmg.o cblas_srot.o  cblas_srotm.o \
        cblas_sswap.o cblas_sscal.o  cblas_scopy.o cblas_saxpy.o \
        cblas_sdot.o  cblas_sdsdot.o cblas_snrm2.o cblas_sasum.o \
        cblas_isamax.o sdotsub.o sdsdotsub.o snrm2sub.o sasumsub.o \
        isamaxsub.o

# Files for level 1 double precision real
dlev1 = cblas_drotg.o cblas_drotmg.o cblas_drot.o  cblas_drotm.o \
        cblas_dswap.o cblas_dscal.o  cblas_dcopy.o cblas_daxpy.o \
        cblas_ddot.o  cblas_dsdot.o  cblas_dnrm2.o cblas_dasum.o \
        cblas_idamax.o ddotsub.o dsdotsub.o dnrm2sub.o \
        dasumsub.o idamaxsub.o

# Files for level 1 single precision complex
clev1 = cblas_crotg.o cblas_csrot.o \
        cblas_cswap.o cblas_cscal.o cblas_csscal.o cblas_ccopy.o \
        cblas_caxpy.o cblas_cdotu_sub.o cblas_cdotc_sub.o \
        cblas_icamax.o cdotcsub.o cdotusub.o icamaxsub.o \
        cblas_scabs1.o scabs1sub.o

# Files for level 1 double precision complex
zlev1 = cblas_zrotg.o cblas_zdrot.o \
        cblas_zswap.o cblas_zscal.o cblas_zdscal.o cblas_zcopy.o \
        cblas_zaxpy.o cblas_zdotu_sub.o cblas_zdotc_sub.o cblas_dznrm2.o \
        cblas_dzasum.o cblas_izamax.o zdotcsub.o zdotusub.o \
        dzasumsub.o dznrm2sub.o izamaxsub.o \
        cblas_dcabs1.o dcabs1sub.o

# Common files for level 1 single precision
sclev1 = cblas_scasum.o scasumsub.o cblas_scnrm2.o scnrm2sub.o

.PHONY: slib1 dlib1 clib1 zlib1
# Single precision real
slib1: $(slev1) $(sclev1)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# Double precision real
dlib1: $(dlev1)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# Single precision complex
clib1: $(clev1) $(sclev1)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# Double precision complex
zlib1: $(zlev1)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

#
#
# CBLAS routines
#
# Level 2
#
#

# Files for level 2 single precision real
slev2 = cblas_sgemv.o cblas_sgbmv.o cblas_sger.o  cblas_ssbmv.o cblas_sspmv.o \
        cblas_sspr.o  cblas_sspr2.o cblas_ssymv.o cblas_ssyr.o  cblas_ssyr2.o \
        cblas_stbmv.o cblas_stbsv.o cblas_stpmv.o cblas_stpsv.o cblas_strmv.o \
        cblas_strsv.o

# Files for level 2 double precision real
dlev2 = cblas_dgemv.o cblas_dgbmv.o cblas_dger.o  cblas_dsbmv.o cblas_dspmv.o \
        cblas_dspr.o  cblas_dspr2.o cblas_dsymv.o cblas_dsyr.o  cblas_dsyr2.o \
        cblas_dtbmv.o cblas_dtbsv.o cblas_dtpmv.o cblas_dtpsv.o cblas_dtrmv.o \
        cblas_dtrsv.o

# Files for level 2 single precision complex
clev2 = cblas_cgemv.o cblas_cgbmv.o cblas_chemv.o cblas_chbmv.o cblas_chpmv.o \
        cblas_ctrmv.o cblas_ctbmv.o cblas_ctpmv.o cblas_ctrsv.o cblas_ctbsv.o \
        cblas_ctpsv.o cblas_cgeru.o cblas_cgerc.o cblas_cher.o  cblas_cher2.o \
        cblas_chpr.o  cblas_chpr2.o

# Files for level 2 double precision complex
zlev2 = cblas_zgemv.o cblas_zgbmv.o cblas_zhemv.o cblas_zhbmv.o cblas_zhpmv.o \
        cblas_ztrmv.o cblas_ztbmv.o cblas_ztpmv.o cblas_ztrsv.o cblas_ztbsv.o \
        cblas_ztpsv.o cblas_zgeru.o cblas_zgerc.o cblas_zher.o  cblas_zher2.o \
        cblas_zhpr.o  cblas_zhpr2.o

.PHONY: slib2 dlib2 clib2 zlib2
# Single precision real
slib2: $(slev2) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# Double precision real
dlib2: $(dlev2) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# Single precision complex
clib2: $(clev2) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# Double precision complex
zlib2: $(zlev2) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

#
#
# CBLAS routines
#
# Level 3
#
#

# Files for level 3 single precision real
slev3 = cblas_sgemm.o cblas_ssymm.o cblas_ssyrk.o cblas_ssyr2k.o cblas_strmm.o \
        cblas_strsm.o cblas_sgemmtr.o

# Files for level 3 double precision real
dlev3 = cblas_dgemm.o cblas_dsymm.o cblas_dsyrk.o cblas_dsyr2k.o cblas_dtrmm.o \
        cblas_dtrsm.o cblas_dgemmtr.o

# Files for level 3 single precision complex
clev3 = cblas_cgemm.o cblas_csymm.o cblas_chemm.o cblas_cherk.o \
        cblas_cher2k.o cblas_ctrmm.o cblas_ctrsm.o cblas_csyrk.o \
        cblas_csyr2k.o cblas_cgemmtr.o

# Files for level 3 double precision complex
zlev3 = cblas_zgemm.o cblas_zsymm.o cblas_zhemm.o cblas_zherk.o \
        cblas_zher2k.o cblas_ztrmm.o cblas_ztrsm.o cblas_zsyrk.o \
        cblas_zsyr2k.o cblas_zgemmtr.o

.PHONY: slib3 dlib3 clib3 zlib3
# Single precision real
slib3: $(slev3) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# Double precision real
dlib3: $(dlev3) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# Single precision complex
clib3: $(clev3) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# Double precision complex
zlib3: $(zlev3) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)


alev1 = $(slev1) $(dlev1) $(clev1) $(zlev1) $(sclev1)
alev2 = $(slev2) $(dlev2) $(clev2) $(zlev2)
alev3 = $(slev3) $(dlev3) $(clev3) $(zlev3)

.PHONY: all1 all2 all3
# All level 1
all1: $(alev1)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# All level 2
all2: $(alev2) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# All level 3
all3: $(alev3) $(errhand)
	$(AR) $(ARFLAGS) $(CBLASLIB) $^
	$(RANLIB) $(CBLASLIB)

# All levels and precisions
$(CBLASLIB): $(alev1) $(alev2) $(alev3) $(errhand)
	$(AR) $(ARFLAGS) $@ $^
	$(RANLIB) $@

FRC:
	@FRC=$(FRC)

.PHONY: clean cleanobj cleanlib
clean: cleanobj cleanlib
cleanobj:
	rm -f *.o
cleanlib:
	rm -f $(CBLASLIB)

=== LAPACKE/example/CMakeLists.txt ===
add_executable(xexample_DGESV_rowmajor example_DGESV_rowmajor.c lapacke_example_aux.c lapacke_example_aux.h)
add_executable(xexample_DGESV_colmajor example_DGESV_colmajor.c lapacke_example_aux.c lapacke_example_aux.h)
add_executable(xexample_DGELS_rowmajor example_DGELS_rowmajor.c lapacke_example_aux.c lapacke_example_aux.h)
add_executable(xexample_DGELS_colmajor example_DGELS_colmajor.c lapacke_example_aux.c lapacke_example_aux.h)

target_link_libraries(xexample_DGESV_rowmajor ${LAPACKELIB} ${BLAS_LIBRARIES})
target_link_libraries(xexample_DGESV_colmajor ${LAPACKELIB} ${BLAS_LIBRARIES})
target_link_libraries(xexample_DGELS_rowmajor ${LAPACKELIB} ${BLAS_LIBRARIES})
target_link_libraries(xexample_DGELS_colmajor ${LAPACKELIB} ${BLAS_LIBRARIES})

add_test(example_DGESV_rowmajor ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/xexample_DGESV_rowmajor)
add_test(example_DGESV_colmajor ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/xexample_DGESV_colmajor)
add_test(example_DGELS_rowmajor ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/xexample_DGELS_rowmajor)
add_test(example_DGELS_colmajor ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/xexample_DGELS_colmajor)

if(BUILD_INDEX64_EXT_API)
  add_executable(xexample_DGESV_rowmajor_64 example_DGESV_rowmajor_64.c lapacke_example_aux.c lapacke_example_aux.h)
  add_executable(xexample_DGESV_colmajor_64 example_DGESV_colmajor_64.c lapacke_example_aux.c lapacke_example_aux.h)
  add_executable(xexample_DGELS_rowmajor_64 example_DGELS_rowmajor_64.c lapacke_example_aux.c lapacke_example_aux.h)
  add_executable(xexample_DGELS_colmajor_64 example_DGELS_colmajor_64.c lapacke_example_aux.c lapacke_example_aux.h)

  target_link_libraries(xexample_DGESV_rowmajor_64 ${LAPACKELIB} ${BLAS_LIBRARIES})
  target_link_libraries(xexample_DGESV_colmajor_64 ${LAPACKELIB} ${BLAS_LIBRARIES})
  target_link_libraries(xexample_DGELS_rowmajor_64 ${LAPACKELIB} ${BLAS_LIBRARIES})
  target_link_libraries(xexample_DGELS_colmajor_64 ${LAPACKELIB} ${BLAS_LIBRARIES})

  add_test(example_DGESV_rowmajor_64 ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/xexample_DGESV_rowmajor_64)
  add_test(example_DGESV_colmajor_64 ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/xexample_DGESV_colmajor_64)
  add_test(example_DGELS_rowmajor_64 ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/xexample_DGELS_rowmajor_64)
  add_test(example_DGELS_colmajor_64 ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/xexample_DGELS_colmajor_64)
endif()

=== LAPACKE/include/CMakeLists.txt ===
set(LAPACKE_INCLUDE lapack.h)
IF(LAPACKE)
    list(APPEND LAPACKE_INCLUDE lapacke.h lapacke_config.h lapacke_utils.h)
endif()

file(COPY ${LAPACKE_INCLUDE} DESTINATION ${LAPACK_BINARY_DIR}/include)

# Create a header file lapacke_mangling.h for the routines called in my C programs
include(CheckLanguage)
check_language(Fortran)
check_language(C)
if(CMAKE_Fortran_COMPILER AND CMAKE_C_COMPILER)
  enable_language(Fortran)
  enable_language(C)
  include(FortranCInterface)
  ## Ensure that the fortran compiler and c compiler specified are compatible
  FortranCInterface_VERIFY()
  FortranCInterface_HEADER(${LAPACK_BINARY_DIR}/include/lapacke_mangling.h
    MACRO_NAMESPACE "LAPACK_"
    SYMBOL_NAMESPACE "LAPACK_")
endif()
if(NOT FortranCInterface_GLOBAL_FOUND OR NOT FortranCInterface_MODULE_FOUND)
  message(WARNING "Reverting to pre-defined include/lapacke_mangling.h")
  configure_file(lapacke_mangling_with_flags.h.in
                 ${LAPACK_BINARY_DIR}/include/lapacke_mangling.h)
endif()

=== LAPACKE/src/Makefile ===
##############################################################################
# Copyright (c) 2014, Intel Corp.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#   * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   * Neither the name of Intel Corporation nor the names of its contributors
#     may be used to endorse or promote products derived from this software
#     without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
##############################################################################
# Contents: Native C interface to LAPACK
# Author: Intel Corporation
##############################################################################
# makefile for LAPACKE, used to build lapacke binary.
#
# Note: we use multiple OBJ_S, OBJ_C, etc, instead of a single OBJ
# to allow build with mingw (argument list too long for the msys ar)
#
TOPSRCDIR = ../..
include $(TOPSRCDIR)/make.inc

.SUFFIXES: .c .o
.c.o:
	$(CC) $(CFLAGS) -Wall -I../include -c -o $@ $<

OBJ = \
lapacke_ilaver.o \
lapacke_nancheck.o

OBJ_C = \
lapacke_cbbcsd.o \
lapacke_cbbcsd_work.o \
lapacke_cbdsqr.o \
lapacke_cbdsqr_work.o \
lapacke_cgbbrd.o \
lapacke_cgbbrd_work.o \
lapacke_cgbcon.o \
lapacke_cgbcon_work.o \
lapacke_cgbequ.o \
lapacke_cgbequ_work.o \
lapacke_cgbequb.o \
lapacke_cgbequb_work.o \
lapacke_cgbrfs.o \
lapacke_cgbrfs_work.o \
lapacke_cgbsv.o \
lapacke_cgbsv_work.o \
lapacke_cgbsvx.o \
lapacke_cgbsvx_work.o \
lapacke_cgbtrf.o \
lapacke_cgbtrf_work.o \
lapacke_cgbtrs.o \
lapacke_cgbtrs_work.o \
lapacke_cgebak.o \
lapacke_cgebak_work.o \
lapacke_cgebal.o \
lapacke_cgebal_work.o \
lapacke_cgebrd.o \
lapacke_cgebrd_work.o \
lapacke_cgecon.o \
lapacke_cgecon_work.o \
lapacke_cgeequ.o \
lapacke_cgeequ_work.o \
lapacke_cgeequb.o \
lapacke_cgeequb_work.o \
lapacke_cgees.o \
lapacke_cgees_work.o \
lapacke_cgeesx.o \
lapacke_cgeesx_work.o \
lapacke_cgeev.o \
lapacke_cgeev_work.o \
lapacke_cgeevx.o \
lapacke_cgeevx_work.o \
lapacke_cgehrd.o \
lapacke_cgehrd_work.o \
lapacke_cgejsv.o \
lapacke_cgejsv_work.o \
lapacke_cgelq.o \
lapacke_cgelq_work.o \
lapacke_cgelq2.o \
lapacke_cgelq2_work.o \
lapacke_cgelqf.o \
lapacke_cgelqf_work.o \
lapacke_cgels.o \
lapacke_cgels_work.o \
lapacke_cgelsd.o \
lapacke_cgelsd_work.o \
lapacke_cgelss.o \
lapacke_cgelss_work.o \
lapacke_cgelsy.o \
lapacke_cgelsy_work.o \
lapacke_cgemlq.o \
lapacke_cgemlq_work.o \
lapacke_cgemqr.o \
lapacke_cgemqr_work.o \
lapacke_cgemqrt.o \
lapacke_cgemqrt_work.o \
lapacke_cgeqlf.o \
lapacke_cgeqlf_work.o \
lapacke_cgeqp3.o \
lapacke_cgeqp3_work.o \
lapacke_cgeqr.o \
lapacke_cgeqr_work.o \
lapacke_cgeqr2.o \
lapacke_cgeqr2_work.o \
lapacke_cgeqrf.o \
lapacke_cgeqrf_work.o \
lapacke_cgeqrfp.o \
lapacke_cgeqrfp_work.o \
lapacke_cgeqrt.o \
lapacke_cgeqrt_work.o \
lapacke_cgeqrt2.o \
lapacke_cgeqrt2_work.o \
lapacke_cgeqrt3.o \
lapacke_cgeqrt3_work.o \
lapacke_cgerfs.o \
lapacke_cgerfs_work.o \
lapacke_cgerqf.o \
lapacke_cgerqf_work.o \
lapacke_cgesdd.o \
lapacke_cgesdd_work.o \
lapacke_cgedmd.o \
lapacke_cgedmd_work.o \
lapacke_cgedmdq.o \
lapacke_cgedmdq_work.o \
lapacke_cgesv.o \
lapacke_cgesv_work.o \
lapacke_cgesvd.o \
lapacke_cgesvd_work.o \
lapacke_cgesvdq.o \
lapacke_cgesvdq_work.o \
lapacke_cgesvdx.o \
lapacke_cgesvdx_work.o \
lapacke_cgesvj.o \
lapacke_cgesvj_work.o \
lapacke_cgesvx.o \
lapacke_cgesvx_work.o \
lapacke_cgetf2.o \
lapacke_cgetf2_work.o \
lapacke_cgetrf.o \
lapacke_cgetrf_work.o \
lapacke_cgetrf2.o \
lapacke_cgetrf2_work.o \
lapacke_cgetri.o \
lapacke_cgetri_work.o \
lapacke_cgetrs.o \
lapacke_cgetrs_work.o \
lapacke_cgetsls.o \
lapacke_cgetsls_work.o \
lapacke_cgetsqrhrt.o \
lapacke_cgetsqrhrt_work.o \
lapacke_cggbak.o \
lapacke_cggbak_work.o \
lapacke_cggbal.o \
lapacke_cggbal_work.o \
lapacke_cgges.o \
lapacke_cgges_work.o \
lapacke_cgges3.o \
lapacke_cgges3_work.o \
lapacke_cggesx.o \
lapacke_cggesx_work.o \
lapacke_cggev.o \
lapacke_cggev_work.o \
lapacke_cggev3.o \
lapacke_cggev3_work.o \
lapacke_cggevx.o \
lapacke_cggevx_work.o \
lapacke_cggglm.o \
lapacke_cggglm_work.o \
lapacke_cgghd3.o \
lapacke_cgghd3_work.o \
lapacke_cgghrd.o \
lapacke_cgghrd_work.o \
lapacke_cgglse.o \
lapacke_cgglse_work.o \
lapacke_cggqrf.o \
lapacke_cggqrf_work.o \
lapacke_cggrqf.o \
lapacke_cggrqf_work.o \
lapacke_cggsvd3.o \
lapacke_cggsvd3_work.o \
lapacke_cggsvp3.o \
lapacke_cggsvp3_work.o \
lapacke_cgtcon.o \
lapacke_cgtcon_work.o \
lapacke_cgtrfs.o \
lapacke_cgtrfs_work.o \
lapacke_cgtsv.o \
lapacke_cgtsv_work.o \
lapacke_cgtsvx.o \
lapacke_cgtsvx_work.o \
lapacke_cgttrf.o \
lapacke_cgttrf_work.o \
lapacke_cgttrs.o \
lapacke_cgttrs_work.o \
lapacke_chbev.o \
lapacke_chbev_work.o \
lapacke_chbev_2stage.o \
lapacke_chbev_2stage_work.o \
lapacke_chbevd.o \
lapacke_chbevd_work.o \
lapacke_chbevd_2stage.o \
lapacke_chbevd_2stage_work.o \
lapacke_chbevx.o \
lapacke_chbevx_work.o \
lapacke_chbevx_2stage.o \
lapacke_chbevx_2stage_work.o \
lapacke_chbgst.o \
lapacke_chbgst_work.o \
lapacke_chbgv.o \
lapacke_chbgv_work.o \
lapacke_chbgvd.o \
lapacke_chbgvd_work.o \
lapacke_chbgvx.o \
lapacke_chbgvx_work.o \
lapacke_chbtrd.o \
lapacke_chbtrd_work.o \
lapacke_checon.o \
lapacke_checon_work.o \
lapacke_checon_3.o \
lapacke_checon_3_work.o \
lapacke_cheequb.o \
lapacke_cheequb_work.o \
lapacke_cheev.o \
lapacke_cheev_work.o \
lapacke_cheev_2stage.o \
lapacke_cheev_2stage_work.o \
lapacke_cheevd.o \
lapacke_cheevd_work.o \
lapacke_cheevd_2stage.o \
lapacke_cheevd_2stage_work.o \
lapacke_cheevr.o \
lapacke_cheevr_work.o \
lapacke_cheevr_2stage.o \
lapacke_cheevr_2stage_work.o \
lapacke_cheevx.o \
lapacke_cheevx_work.o \
lapacke_cheevx_2stage.o \
lapacke_cheevx_2stage_work.o \
lapacke_chegst.o \
lapacke_chegst_work.o \
lapacke_chegv.o \
lapacke_chegv_work.o \
lapacke_chegv_2stage.o \
lapacke_chegv_2stage_work.o \
lapacke_chegvd.o \
lapacke_chegvd_work.o \
lapacke_chegvx.o \
lapacke_chegvx_work.o \
lapacke_cherfs.o \
lapacke_cherfs_work.o \
lapacke_chesv.o \
lapacke_chesv_work.o \
lapacke_chesv_aa.o \
lapacke_chesv_aa_work.o \
lapacke_chesv_aa_2stage.o \
lapacke_chesv_aa_2stage_work.o \
lapacke_chesv_rk.o \
lapacke_chesv_rk_work.o \
lapacke_chesvx.o \
lapacke_chesvx_work.o \
lapacke_cheswapr.o \
lapacke_cheswapr_work.o \
lapacke_chetrd.o \
lapacke_chetrd_work.o \
lapacke_chetrf.o \
lapacke_chetrf_work.o \
lapacke_chetrf_aa.o \
lapacke_chetrf_aa_work.o \
lapacke_chetrf_aa_2stage.o \
lapacke_chetrf_aa_2stage_work.o \
lapacke_chetrf_rk.o \
lapacke_chetrf_rk_work.o \
lapacke_chetrf_rook.o \
lapacke_chetrf_rook_work.o \
lapacke_chetri.o \
lapacke_chetri_work.o \
lapacke_chetri2.o \
lapacke_chetri2_work.o \
lapacke_chetri2x.o \
lapacke_chetri2x_work.o \
lapacke_chetri_3.o \
lapacke_chetri_3_work.o \
lapacke_chetrs.o \
lapacke_chetrs_work.o \
lapacke_chetrs2.o \
lapacke_chetrs2_work.o \
lapacke_chetrs_3.o \
lapacke_chetrs_3_work.o \
lapacke_chetrs_aa.o \
lapacke_chetrs_aa_work.o \
lapacke_chetrs_aa_2stage.o \
lapacke_chetrs_aa_2stage_work.o \
lapacke_chetrs_rook.o \
lapacke_chetrs_rook_work.o \
lapacke_chfrk.o \
lapacke_chfrk_work.o \
lapacke_chgeqz.o \
lapacke_chgeqz_work.o \
lapacke_chpcon.o \
lapacke_chpcon_work.o \
lapacke_chpev.o \
lapacke_chpev_work.o \
lapacke_chpevd.o \
lapacke_chpevd_work.o \
lapacke_chpevx.o \
lapacke_chpevx_work.o \
lapacke_chpgst.o \
lapacke_chpgst_work.o \
lapacke_chpgv.o \
lapacke_chpgv_work.o \
lapacke_chpgvd.o \
lapacke_chpgvd_work.o \
lapacke_chpgvx.o \
lapacke_chpgvx_work.o \
lapacke_chprfs.o \
lapacke_chprfs_work.o \
lapacke_chpsv.o \
lapacke_chpsv_work.o \
lapacke_chpsvx.o \
lapacke_chpsvx_work.o \
lapacke_chptrd.o \
lapacke_chptrd_work.o \
lapacke_chptrf.o \
lapacke_chptrf_work.o \
lapacke_chptri.o \
lapacke_chptri_work.o \
lapacke_chptrs.o \
lapacke_chptrs_work.o \
lapacke_chsein.o \
lapacke_chsein_work.o \
lapacke_chseqr.o \
lapacke_chseqr_work.o \
lapacke_clacgv.o \
lapacke_clacgv_work.o \
lapacke_clacn2.o \
lapacke_clacn2_work.o \
lapacke_clacp2.o \
lapacke_clacp2_work.o \
lapacke_clacpy.o \
lapacke_clacpy_work.o \
lapacke_clacrm.o \
lapacke_clacrm_work.o \
lapacke_clag2z.o \
lapacke_clag2z_work.o \
lapacke_clangb.o \
lapacke_clangb_work.o \
lapacke_clange.o \
lapacke_clange_work.o \
lapacke_clanhe.o \
lapacke_clanhe_work.o \
lapacke_clansy.o \
lapacke_clansy_work.o \
lapacke_clantr.o \
lapacke_clantr_work.o \
lapacke_clapmr.o \
lapacke_clapmr_work.o \
lapacke_clapmt.o \
lapacke_clapmt_work.o \
lapacke_clarcm.o \
lapacke_clarcm_work.o \
lapacke_clarfb.o \
lapacke_clarfb_work.o \
lapacke_clarfg.o \
lapacke_clarfg_work.o \
lapacke_clarft.o \
lapacke_clarft_work.o \
lapacke_clarfx.o \
lapacke_clarfx_work.o \
lapacke_clarnv.o \
lapacke_clarnv_work.o \
lapacke_clascl.o \
lapacke_clascl_work.o \
lapacke_claset.o \
lapacke_claset_work.o \
lapacke_classq.o \
lapacke_classq_work.o \
lapacke_claswp.o \
lapacke_claswp_work.o \
lapacke_clauum.o \
lapacke_clauum_work.o \
lapacke_cpbcon.o \
lapacke_cpbcon_work.o \
lapacke_cpbequ.o \
lapacke_cpbequ_work.o \
lapacke_cpbrfs.o \
lapacke_cpbrfs_work.o \
lapacke_cpbstf.o \
lapacke_cpbstf_work.o \
lapacke_cpbsv.o \
lapacke_cpbsv_work.o \
lapacke_cpbsvx.o \
lapacke_cpbsvx_work.o \
lapacke_cpbtrf.o \
lapacke_cpbtrf_work.o \
lapacke_cpbtrs.o \
lapacke_cpbtrs_work.o \
lapacke_cpftrf.o \
lapacke_cpftrf_work.o \
lapacke_cpftri.o \
lapacke_cpftri_work.o \
lapacke_cpftrs.o \
lapacke_cpftrs_work.o \
lapacke_cpocon.o \
lapacke_cpocon_work.o \
lapacke_cpoequ.o \
lapacke_cpoequ_work.o \
lapacke_cpoequb.o \
lapacke_cpoequb_work.o \
lapacke_cporfs.o \
lapacke_cporfs_work.o \
lapacke_cposv.o \
lapacke_cposv_work.o \
lapacke_cposvx.o \
lapacke_cposvx_work.o \
lapacke_cpotrf.o \
lapacke_cpotrf_work.o \
lapacke_cpotrf2.o \
lapacke_cpotrf2_work.o \
lapacke_cpotri.o \
lapacke_cpotri_work.o \
lapacke_cpotrs.o \
lapacke_cpotrs_work.o \
lapacke_cppcon.o \
lapacke_cppcon_work.o \
lapacke_cppequ.o \
lapacke_cppequ_work.o \
lapacke_cpprfs.o \
lapacke_cpprfs_work.o \
lapacke_cppsv.o \
lapacke_cppsv_work.o \
lapacke_cppsvx.o \
lapacke_cppsvx_work.o \
lapacke_cpptrf.o \
lapacke_cpptrf_work.o \
lapacke_cpptri.o \
lapacke_cpptri_work.o \
lapacke_cpptrs.o \
lapacke_cpptrs_work.o \
lapacke_cpstrf.o \
lapacke_cpstrf_work.o \
lapacke_cptcon.o \
lapacke_cptcon_work.o \
lapacke_cpteqr.o \
lapacke_cpteqr_work.o \
lapacke_cptrfs.o \
lapacke_cptrfs_work.o \
lapacke_cptsv.o \
lapacke_cptsv_work.o \
lapacke_cptsvx.o \
lapacke_cptsvx_work.o \
lapacke_cpttrf.o \
lapacke_cpttrf_work.o \
lapacke_cpttrs.o \
lapacke_cpttrs_work.o \
lapacke_cspcon.o \
lapacke_cspcon_work.o \
lapacke_csprfs.o \
lapacke_csprfs_work.o \
lapacke_cspsv.o \
lapacke_cspsv_work.o \
lapacke_cspsvx.o \
lapacke_cspsvx_work.o \
lapacke_csptrf.o \
lapacke_csptrf_work.o \
lapacke_csptri.o \
lapacke_csptri_work.o \
lapacke_csptrs.o \
lapacke_csptrs_work.o \
lapacke_cstedc.o \
lapacke_cstedc_work.o \
lapacke_cstegr.o \
lapacke_cstegr_work.o \
lapacke_cstein.o \
lapacke_cstein_work.o \

=== TESTING/EIG/CMakeLists.txt ===
########################################################################
#  This is the makefile for the eigenvalue test program from LAPACK.
#  The test files are organized as follows:
#
#     AEIGTST -- Auxiliary test routines used in all precisions
#     SCIGTST -- Auxiliary test routines used in single precision
#     DZIGTST -- Auxiliary test routines used in double precision
#     SEIGTST -- Single precision real test routines
#     CEIGTST -- Single precision complex test routines
#     DEIGTST -- Double precision real test routines
#     ZEIGTST -- Double precision complex test routines
#
########################################################################

set(AEIGTST
   alahdg.f
   alasum.f
   alasvm.f
   alareq.f
   ilaenv.f
   xerbla.f
   xlaenv.f
   chkxer.f)

set(SCIGTST slafts.f slahd2.f slasum.f slatb9.f sstech.f sstect.f
   ssvdch.f ssvdct.f ssxt1.f)

set(SEIGTST schkee.F
   sbdt01.f sbdt02.f sbdt03.f sbdt04.f sbdt05.f
   schkbb.f schkbd.f schkbk.f schkbl.f schkec.f
   schkgg.f schkgk.f schkgl.f schkhs.f schksb.f schkst.f schkst2stg.f schksb2stg.f
   sckcsd.f sckglm.f sckgqr.f sckgsv.f scklse.f scsdts.f
   sdrges.f sdrgev.f sdrges3.f sdrgev3.f sdrgsx.f sdrgvx.f
   sdrvbd.f sdrves.f sdrvev.f sdrvsg.f sdrvsg2stg.f
   sdrvst.f sdrvst2stg.f sdrvsx.f sdrvvx.f
   serrbd.f serrec.f serred.f serrgg.f serrhs.f serrst.f
   sget02.f sget10.f sget22.f sget23.f sget24.f sget31.f
   sget32.f sget33.f sget34.f sget35.f sget36.f
   sget37.f sget38.f sget39.f sget40.f sget51.f sget52.f sget53.f
   sget54.f sglmts.f sgqrts.f sgrqts.f sgsvts3.f
   shst01.f slarfy.f slarhs.f slatm4.f slctes.f slctsx.f slsets.f sort01.f
   sort03.f ssbt21.f ssgt01.f sslect.f sspt21.f sstt21.f
   sstt22.f ssyl01.f ssyt21.f ssyt22.f)

set(SDMDEIGTST schkdmd.f90)

set(CEIGTST cchkee.F
   cbdt01.f cbdt02.f cbdt03.f cbdt05.f
   cchkbb.f cchkbd.f cchkbk.f cchkbl.f cchkec.f
   cchkgg.f cchkgk.f cchkgl.f cchkhb.f cchkhs.f cchkst.f cchkst2stg.f cchkhb2stg.f
   cckcsd.f cckglm.f cckgqr.f cckgsv.f ccklse.f ccsdts.f
   cdrges.f cdrgev.f cdrges3.f cdrgev3.f cdrgsx.f cdrgvx.f
   cdrvbd.f cdrves.f cdrvev.f cdrvsg.f cdrvsg2stg.f
   cdrvst.f cdrvst2stg.f cdrvsx.f cdrvvx.f
   cerrbd.f cerrec.f cerred.f cerrgg.f cerrhs.f cerrst.f
   cget02.f cget10.f cget22.f cget23.f cget24.f
   cget35.f cget36.f cget37.f cget38.f cget51.f cget52.f
   cget54.f cglmts.f cgqrts.f cgrqts.f cgsvts3.f
   chbt21.f chet21.f chet22.f chpt21.f chst01.f
   clarfy.f clarhs.f clatm4.f clctes.f clctsx.f clsets.f csbmv.f
   csgt01.f cslect.f csyl01.f
   cstt21.f cstt22.f cunt01.f cunt03.f)

set(CDMDEIGTST cchkdmd.f90)

set(DZIGTST dlafts.f dlahd2.f dlasum.f dlatb9.f dstech.f dstect.f
   dsvdch.f dsvdct.f dsxt1.f)

set(DEIGTST dchkee.F
   dbdt01.f dbdt02.f dbdt03.f dbdt04.f dbdt05.f
   dchkbb.f dchkbd.f dchkbk.f dchkbl.f dchkec.f
   dchkgg.f dchkgk.f dchkgl.f dchkhs.f dchksb.f dchkst.f dchkst2stg.f dchksb2stg.f
   dckcsd.f dckglm.f dckgqr.f dckgsv.f dcklse.f dcsdts.f
   ddrges.f ddrgev.f ddrges3.f ddrgev3.f ddrgsx.f ddrgvx.f
   ddrvbd.f ddrves.f ddrvev.f ddrvsg.f ddrvsg2stg.f
   ddrvst.f ddrvst2stg.f ddrvsx.f ddrvvx.f
   derrbd.f derrec.f derred.f derrgg.f derrhs.f derrst.f
   dget02.f dget10.f dget22.f dget23.f dget24.f dget31.f
   dget32.f dget33.f dget34.f dget35.f dget36.f
   dget37.f dget38.f dget39.f dget40.f dget51.f dget52.f dget53.f
   dget54.f dglmts.f dgqrts.f dgrqts.f dgsvts3.f
   dhst01.f dlarfy.f dlarhs.f dlatm4.f dlctes.f dlctsx.f dlsets.f dort01.f
   dort03.f dsbt21.f dsgt01.f dslect.f dspt21.f dstt21.f
   dstt22.f dsyl01.f dsyt21.f dsyt22.f)

set(DDMDEIGTST dchkdmd.f90)

set(ZEIGTST zchkee.F
   zbdt01.f zbdt02.f zbdt03.f zbdt05.f
   zchkbb.f zchkbd.f zchkbk.f zchkbl.f zchkec.f
   zchkgg.f zchkgk.f zchkgl.f zchkhb.f zchkhs.f zchkst.f zchkst2stg.f zchkhb2stg.f
   zckcsd.f zckglm.f zckgqr.f zckgsv.f zcklse.f zcsdts.f
   zdrges.f zdrgev.f zdrges3.f zdrgev3.f zdrgsx.f zdrgvx.f
   zdrvbd.f zdrves.f zdrvev.f zdrvsg.f zdrvsg2stg.f
   zdrvst.f zdrvst2stg.f zdrvsx.f zdrvvx.f
   zerrbd.f zerrec.f zerred.f zerrgg.f zerrhs.f zerrst.f
   zget02.f zget10.f zget22.f zget23.f zget24.f
   zget35.f zget36.f zget37.f zget38.f zget51.f zget52.f
   zget54.f zglmts.f zgqrts.f zgrqts.f zgsvts3.f
   zhbt21.f zhet21.f zhet22.f zhpt21.f zhst01.f
   zlarfy.f zlarhs.f zlatm4.f zlctes.f zlctsx.f zlsets.f zsbmv.f
   zsgt01.f zslect.f zsyl01.f
   zstt21.f zstt22.f zunt01.f zunt03.f)

set(ZDMDEIGTST zchkdmd.f90)

macro(add_eig_executable name)
  add_executable(${name} ${ARGN})
  target_link_libraries(${name} ${TMGLIB} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
endmacro()

if(BUILD_SINGLE)
add_eig_executable(xeigtsts ${SEIGTST} ${SCIGTST} ${AEIGTST})
add_eig_executable(xdmdeigtsts ${SDMDEIGTST})
endif()

if(BUILD_COMPLEX)
add_eig_executable(xeigtstc ${CEIGTST} ${SCIGTST} ${AEIGTST})
add_eig_executable(xdmdeigtstc ${CDMDEIGTST})
endif()


if(BUILD_DOUBLE)
add_eig_executable(xeigtstd ${DEIGTST} ${DZIGTST} ${AEIGTST})
add_eig_executable(xdmdeigtstd ${DDMDEIGTST})
endif()

if(BUILD_COMPLEX16)
add_eig_executable(xeigtstz ${ZEIGTST} ${DZIGTST} ${AEIGTST})
add_eig_executable(xdmdeigtstz ${ZDMDEIGTST})
endif()

=== debian/changelog ===
lapack (3.12.1-7ubuntu1) resolute; urgency=medium

  * d/rules: switch sed separator for LDFLAGS to cope with dpkg (LP: #2138222)

 -- Nick Rosbrook <enr0n@ubuntu.com>  Mon, 12 Jan 2026 13:30:09 -0500

lapack (3.12.1-7) unstable; urgency=medium

   * Team upload
   * No-change rebuild for IEEE long double on ppc64el

 -- Graham Inggs <ginggs@debian.org>  Thu, 04 Sep 2025 09:51:09 +0000

lapack (3.12.1-6) unstable; urgency=medium

  * Revise the deps for libatlas3-base (transitional) as suggested in #1110359
    Thanks to Simon McVittie for the suggestion.

 -- Mo Zhou <lumin@debian.org>  Thu, 07 Aug 2025 13:26:25 -0400

lapack (3.12.1-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix libatlas3-base: insufficient dependency on libblas3 (Closes: #1110359)

 -- Mo Zhou <lumin@debian.org>  Tue, 05 Aug 2025 16:53:57 -0400

lapack (3.12.1-4) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sat, 19 Jul 2025 21:40:05 -0400

lapack (3.12.1-3) experimental; urgency=medium

  [ Jochen Sprickerhof ]
  * Add libatlas3-base transitional dummy package (Closes: #1109176)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 19 Jul 2025 14:35:40 +0200

lapack (3.12.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Mon, 27 Jan 2025 19:54:31 -0500

lapack (3.12.1-1) experimental; urgency=medium

  * New upstream version 3.12.1 (Jan 2025)
  * Remove patches that were merged to upstream, and refresh remaining ones.
  * d/rules: real.3 and imag.3 no longer exists.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Tue, 14 Jan 2025 11:19:47 -0500

lapack (3.12.0-4) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS
    + Translate gfortran dependency to gfortran-for-host.
    + Annotate test dependency python3 with the nocheck profile.
    (Closes: #1086680)

  [ Sébastien Villemot ]
  * Bump Standards-Version to 4.7.0

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 20 Nov 2024 11:13:36 +0100

=== debian/control ===
Source: lapack
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>,
           Mo Zhou <lumin@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec
Build-Depends-Arch: gfortran-for-host,
                    python3 <!nocheck>
Build-Depends-Indep: doxygen,
                     graphviz,
                     rename
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/lapack
Vcs-Git: https://salsa.debian.org/science-team/lapack.git
Homepage: https://www.netlib.org/lapack/
Rules-Requires-Root: no

Package: liblapack3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: liblapack.so.3
Description: Library of linear algebra routines 3 - shared version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains a shared version of the library.

Package: liblapack64-3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: liblapack64.so.3
Description: Library of linear algebra routines 3 - shared version (64bit-index)
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains a shared version of the library.
 Compiled with Fortran option "-fdefault-integer-8".

Package: liblapacke
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: liblapacke.so.3
# liblapack3 3.12 added new symbols, which are needed by liblapacke 3.12 at dynamic linking.
# Because of the alternatives mechanism for liblapack.so.3, it is impossible to express this
# relationship using versioned dependencies (the dependency may be satisfied by a flavour, but
# the alternative may point to some other flavour not satisfying the version restriction).
# Only a breaks relationship can ensure that there is no broken combination, even if it does
# not correctly express the intent.
Breaks: liblapack3 (<< 3.12),
        libopenblas0-serial (<< 0.3.25+ds-2),
        libopenblas0-pthread (<< 0.3.25+ds-2),
        libopenblas0-openmp (<< 0.3.25+ds-2),
        libatlas3-base (<< 3.10.3-14)
Description: Library of linear algebra routines 3 - C lib shared version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains the Standard C language library for LAPACK.

Package: liblapacke64
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: liblapacke64.so.3
Description: Library of linear algebra routines 3 - C lib shared version (64bit-index)
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains the Standard C language library for LAPACK.
 Compiled with C flag "-DHAVE_LAPACK_CONFIG_H -DLAPACK_ILP64".

Package: liblapacke-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         liblapacke (= ${binary:Version}),
         libblas-dev | libblas.so,
         liblapack-dev | liblapack.so,
         libtmglib-dev
Suggests: liblapack-doc
Breaks: liblapacke (<< 3.8.0-3)
Replaces: liblapacke (<< 3.8.0-3)
Description: Library of linear algebra routines 3 () - Headers
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains development files for the C language library for LAPACK,
 including a static version of the library.

Package: liblapacke64-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         liblapacke64 (= ${binary:Version}),
         libblas64-dev | libblas64.so,
         liblapack64-dev | liblapack64.so,
         libtmglib64-dev
Suggests: liblapack-doc
Description: Library of linear algebra routines 3 - Headers (64bit-index)
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains development files for the C language library for LAPACK,
 including a static version of the library.
 Compiled with C flag "-DHAVE_LAPACK_CONFIG_H -DLAPACK_ILP64".

Package: libtmglib3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: test matrix generators of LAPACK - shared version
 libtmglib is a component of the LAPACK library, containing routines for
 generation of input matrices for testing and timing of LAPACK.
 .
 This package contains a shared version of the library.

Package: libtmglib64-3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: test matrix generators of LAPACK - shared version (64bit-index)
 libtmglib is a component of the LAPACK library, containing routines for
 generation of input matrices for testing and timing of LAPACK.
 .
 This package contains a shared version of the library.
 Compiled with Fortran flag "-fdefault-integer-8".

Package: libtmglib-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libtmglib3 (= ${binary:Version}),
         libblas-dev | libblas.so,
         liblapack-dev | liblapack.so
Description: test matrix generators of LAPACK - development files
 libtmglib is a component of the LAPACK library, containing routines for
 generation of input matrices for testing and timing of LAPACK.
 .
 This package contains development files, including a static version of the
 library.

Package: libtmglib64-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libtmglib64-3 (= ${binary:Version}),
         libblas64-dev | libblas64.so,
         liblapack64-dev | liblapack64.so
Description: test matrix generators of LAPACK - development files (64bit-index)
 libtmglib is a component of the LAPACK library, containing routines for
 generation of input matrices for testing and timing of LAPACK.
 .
 This package contains development files, including a static version of the
 library.
 Compiled with Fortran flag "-fdefault-integer-8".

Package: liblapack-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         liblapack3 (= ${binary:Version}),
         libblas-dev | libblas.so
Suggests: liblapack-doc
Provides: liblapack.so
Description: Library of linear algebra routines 3 - static version
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains a static version of the library.

Package: liblapack64-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         liblapack64-3 (= ${binary:Version}),
         libblas64-dev | libblas64.so
Suggests: liblapack-doc
Provides: liblapack64.so
Description: Library of linear algebra routines 3 - static version (64bit-index)
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains a static version of the library.
 Compiled with Fortran flag "-fdefault-integer-8".

Package: liblapack-test
Architecture: any
Multi-Arch: same
Section: devel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: python3
Description: Library of linear algebra routines 3 - testing programs
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 These testing programs have been run against the
 shared library in the lapack package.  The results have been
 collected in the files test_results.  These
 programs are provided separately here so that the user can
 test and compare alternate versions of the lapack libraries,
 such as those provided by the ATLAS packages, and the lapack
 package.

Package: liblapack64-test
Architecture: any
Multi-Arch: same
Section: devel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: python3
Description: Library of linear algebra routines 3 - testing programs (64bit-index)
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 These testing programs have been run against the
 shared library in the lapack package.  The results have been
 collected in the files test_results.  These
 programs are provided separately here so that the user can
 test and compare alternate versions of the lapack libraries,
 such as those provided by the ATLAS packages, and the lapack
 package.
 .
 Compiled with Fortran option "-fdefault-integer-8".

Package: liblapack-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Library of linear algebra routines 3 - documentation
 LAPACK version 3.X is a comprehensive FORTRAN library that does
 linear algebra operations including matrix inversions, least
 squared solutions to linear sets of equations, eigenvector
 analysis, singular value decomposition, etc. It is a very
 comprehensive and reputable package that has found extensive
 use in the scientific community.
 .
 This package contains:
  - manpages of BLAS and LAPACK routines,
  - the Lapack User's Guide manual (in HTML),
  - the manual for the LAPACKE C interface to LAPACK (in PDF).

Package: libblas3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Provides: libblas.so.3
Description: Basic Linear Algebra Reference implementations, shared library

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# xerblas_ and LAPACK_xerblas must be overrideable by applications
# --dynamic-list does not work with gold, so drop the flag completely
export DEB_LDFLAGS_MAINT_STRIP = "-Wl,-Bsymbolic-functions"

include /usr/share/dpkg/default.mk

SO:=3

# if FC isn't explicitly set (default or undefined), set it to the compiler for
# our host architecture. This may be a cross compiler
ifneq ($(filter default undefined,$(origin FC)),)
FC := $(DEB_HOST_GNU_TYPE)-gfortran
endif

FFLAGS_NOOPT:=$(shell DEB_BUILD_OPTIONS=noopt dpkg-buildflags --get FFLAGS)

# if CC isn't explicitly set (default or undefined), set it to the compiler for
# our host architecture. This may be a cross compiler
ifneq ($(filter default undefined,$(origin CC)),)
CC := $(DEB_HOST_GNU_TYPE)-gcc
endif

ifeq ($(DEB_HOST_ARCH),alpha)
  FFLAGS += -mieee
  FFLAGS_NOOPT += -mieee
endif

# Using the -frecursive flag is the solution recommended by upstream for #693269
# However, we don't want to use -frecursive for the LAPACK testsuite, it leads to
#  segfaults on mips{,el} (xeigtstz allocates too much space on the stack)
FFLAGS_LAPACK_TESTSUITE := $(FFLAGS)
FFLAGS += -frecursive
FFLAGS_NOOPT += -frecursive

# On arches with extended precision, this flag is used
# for BLAS when compiling i{c,z}amax.f and the BLAS testsuite,
# in order to avoid test failures.
# See also debian/patches/icamax-izamax-extended-precision.patch
ifneq (,$(filter $(DEB_HOST_ARCH_CPU),i386 m68k))
  FFLAGS_FLOAT_STORE := -ffloat-store
  export FFLAGS_FLOAT_STORE
endif

FFLAGS_BLAS_TESTSUITE := $(FFLAGS) $(FFLAGS_FLOAT_STORE)

# Support parallel build
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

ifneq (64,$(DEB_HOST_ARCH_BITS))
export DH_OPTIONS = \
	-Nlibblas64-3 -Nlibblas64-dev \
	-Nliblapack64-3 -Nliblapack64-dev \
	-Nliblapacke64 -Nliblapacke64-dev \
	-Nlibtmglib64-3 -Nlibtmglib64-dev \
	-Nlibblas64-test -Nliblapack64-test
endif

%:
	dh $@

make.inc-32: INSTALL/make.inc.gfortran
	sed -e "s%\(^CC  *=\).*%\1 $(CC)%1" \
	    -e "s%\(^FC  *=\).*%\1 $(FC)%1" \
	    -e "s%\(^FFLAGS_NOOPT  *=\).*%\1 \$$(PICOPTS) $(FFLAGS_NOOPT)%1" \
	    -e "s%\(^FFLAGS  *=\).*%\1 \$$(PICOPTS) $(FFLAGS)%1" \
	    -e "s#\(^LDFLAGS  *=\).*#\1 $(LDFLAGS)#1" \
	    -e "s%\(^AR  *=\).*%\1 $(DEB_HOST_GNU_TYPE)-ar%1" \
	    -e "s%\(^RANLIB  *=\).*%\1 $(DEB_HOST_GNU_TYPE)-ranlib%1" \
	    -e "s%\(^CFLAGS  *=\).*%\1 $(CPPFLAGS) \$$(PICOPTS) $(CFLAGS)%1" \
	    -e "s%^#\(LAPACKE_WITH_TMG  *=\)%\1%1" \
	    < $< > $@
	# Build deprecated routines (see #810143)
	echo "BUILD_DEPRECATED=1" >> $@
	ln -sf make.inc-32 make.inc # make default

make.inc-64: INSTALL/make.inc.gfortran
	sed -e "s%\(^CC  *=\).*%\1 $(CC)%1" \
	    -e "s%\(^FC  *=\).*%\1 $(FC)%1" \
	    -e "s%\(^FFLAGS_NOOPT  *=\).*%\1 \$$(PICOPTS) -fdefault-integer-8 $(FFLAGS_NOOPT)%1" \
	    -e "s%\(^FFLAGS  *=\).*%\1 \$$(PICOPTS) -fdefault-integer-8 $(FFLAGS)%1" \
	    -e "s#\(^LDFLAGS  *=\).*#\1 $(LDFLAGS)#1" \
	    -e "s%\(^AR  *=\).*%\1 $(DEB_HOST_GNU_TYPE)-ar%1" \
	    -e "s%\(^RANLIB  *=\).*%\1 $(DEB_HOST_GNU_TYPE)-ranlib%1" \
	    -e "s%\(^CFLAGS  *=\).*%\1 $(CPPFLAGS) \$$(PICOPTS) -DHAVE_LAPACK_CONFIG_H -DWeirdNEC -DLAPACK_ILP64 $(CFLAGS)%1" \
	    -e "s%^#\(LAPACKE_WITH_TMG  *=\)%\1%1" \
	    < $< > $@
	# Build deprecated routines as well
	echo "BUILD_DEPRECATED=1" >> $@

override_dh_auto_clean: make.inc-32 make.inc-64
	$(MAKE) clean
	rm -rf debian/*_stamp debian/*_results lib*.so*
	rm -rf pic32/ pic64/ static-32/ static-64/
	rm -rf debian/test/ debian/time/
	rm -f TESTING/tmp TESTING/testing_results.txt
	rm -f CBLAS/include/cblas_mangling.h
	rm -rf DOCS/explore-html/ DOCS/man/
	rm -f output_err
	rm -f lapack-netlib.pc LAPACKE/lapacke.pc BLAS/blas-netlib.pc
	rm -f lapack64-netlib.pc LAPACKE/lapacke64.pc BLAS/blas64-netlib.pc
	rm -rf INSTALL64/ BLAS64/ CBLAS64/ SRC64/ LAPACKE64/ TESTING64/
	-$(RM) -f make.inc*

override_dh_auto_configure: make.inc-32 make.inc-64
	# Create lapack-netlib.pc
	sed -e "s%@LAPACK_VERSION@%$(DEB_VERSION_UPSTREAM)%" \
	    -e "s%@CMAKE_INSTALL_FULL_INCLUDEDIR@%/usr/include/$(DEB_HOST_MULTIARCH)%"  \
	    -e "s%@CMAKE_INSTALL_FULL_LIBDIR@%/usr/lib/$(DEB_HOST_MULTIARCH)%" < lapack.pc.in > lapack-netlib.pc

	# Create lapack64-netlib.pc
	sed -e "s%@LAPACK_VERSION@%$(DEB_VERSION_UPSTREAM)%" \
	    -e "s%@CMAKE_INSTALL_FULL_INCLUDEDIR@%/usr/include/$(DEB_HOST_MULTIARCH)%"  \
	    -e "s%@CMAKE_INSTALL_FULL_LIBDIR@%/usr/lib/$(DEB_HOST_MULTIARCH)%"	\
	    -e "s/Name: LAPACK$$/Name: LAPACK64/" \
	    -e "s/-llapack/-llapack64/" \
	    -e "s/Requires.private: blas$$/Requires.private: blas64/" < lapack.pc.in > lapack64-netlib.pc

	# Create lapacke.pc
	sed -e "s%@LAPACK_VERSION@%$(DEB_VERSION_UPSTREAM)%" \
	    -e "s%@LAPACKLIB@%lapack%" \
	    -e "s%@LAPACKELIB@%lapacke%" \
	    -e "s%@CMAKE_INSTALL_FULL_INCLUDEDIR@%/usr/include/$(DEB_HOST_MULTIARCH)%"  \
	    -e "s%@CMAKE_INSTALL_FULL_LIBDIR@%/usr/lib/$(DEB_HOST_MULTIARCH)%" < LAPACKE/lapacke.pc.in > LAPACKE/lapacke.pc

	# Create lapacke64.pc
	sed -e "s%@LAPACK_VERSION@%$(DEB_VERSION_UPSTREAM)%" \
	    -e "s%@LAPACKLIB@%lapack64%" \
	    -e "s%@LAPACKELIB@%lapacke64%" \
	    -e "s%@CMAKE_INSTALL_FULL_INCLUDEDIR@%/usr/include/$(DEB_HOST_MULTIARCH)%"  \
	    -e "s%@CMAKE_INSTALL_FULL_LIBDIR@%/usr/lib/$(DEB_HOST_MULTIARCH)%"	\
	    -e "s/Name: LAPACKE$$/Name: LAPACKE64/" < LAPACKE/lapacke.pc.in > LAPACKE/lapacke64.pc

	# Create blas-netlib.pc
	sed -e "s%@LAPACK_VERSION@%$(DEB_VERSION_UPSTREAM)%" \
	    -e "s%@BLASLIB@%blas%" \
	    -e "s%@CMAKE_INSTALL_FULL_INCLUDEDIR@%/usr/include/$(DEB_HOST_MULTIARCH)%"  \
	    -e "s%@CMAKE_INSTALL_FULL_LIBDIR@%/usr/lib/$(DEB_HOST_MULTIARCH)%" < BLAS/blas.pc.in > BLAS/blas-netlib.pc

	# Create blas64-netlib.pc
	sed -e "s%@LAPACK_VERSION@%$(DEB_VERSION_UPSTREAM)%" \
	    -e "s%@BLASLIB@%blas64%" \
	    -e "s%@CMAKE_INSTALL_FULL_INCLUDEDIR@%/usr/include/$(DEB_HOST_MULTIARCH)%"  \
	    -e "s%@CMAKE_INSTALL_FULL_LIBDIR@%/usr/lib/$(DEB_HOST_MULTIARCH)%"	\
	    -e "s/Name: BLAS$$/Name: BLAS64/" < BLAS/blas.pc.in > BLAS/blas64-netlib.pc

	# Create source directories for 64-bit indexing variant
	for I in INSTALL BLAS CBLAS SRC LAPACKE TESTING; do cp -r $$I $${I}64; done
	sed -i "s%../INSTALL/%../INSTALL64/%g" SRC64/Makefile

override_dh_auto_build-arch:
	###########################################################################
	## 32-BIT INDEXING -- SHARED (PIC)
	ln -sf make.inc-32 make.inc
	###########################################################################
	# Build pic libraries
	$(MAKE) clean
	$(MAKE) blaslib cblaslib lapacklib tmglib lapackelib PICOPTS=-fPIC
	mkdir -p pic32
	for I in refblas cblas lapack tmglib lapacke; do cp lib$${I}.a pic32/lib$${I}_pic.a; done

	# Build libblas.so.*
	ar d pic32/librefblas_pic.a xerbla.o # We want to use the xerbla.o from libcblas_pic.a
	mkdir -p tmp
	cd tmp && ar x ../pic32/librefblas_pic.a && ar x ../pic32/libcblas_pic.a
	$(FC) -shared -Wl,-soname=libblas.so.$(SO) -o libblas.so.$(DEB_VERSION_UPSTREAM) tmp/*.o $(LDFLAGS)
	rm -rf tmp
	ln -s libblas.so.$(DEB_VERSION_UPSTREAM) libblas.so.$(SO)
	ln -s libblas.so.$(DEB_VERSION_UPSTREAM) libblas.so

	# Build liblapack.so.*
	mkdir -p tmp
	cd tmp && ar x ../pic32/liblapack_pic.a
	$(FC) -shared -Wl,-soname=liblapack.so.$(SO) -o liblapack.so.$(DEB_VERSION_UPSTREAM) tmp/*.o  -L. -lblas $(LDFLAGS)
	rm -rf tmp
	ln -s liblapack.so.$(DEB_VERSION_UPSTREAM) liblapack.so.$(SO)
	ln -s liblapack.so.$(DEB_VERSION_UPSTREAM) liblapack.so

	# Build libtmglib.so.*
	mkdir -p tmp
	cd tmp && ar x ../pic32/libtmglib_pic.a
	$(FC) -shared -Wl,-soname=libtmglib.so.$(SO) -o libtmglib.so.$(DEB_VERSION_UPSTREAM) tmp/*.o  -L. -lblas -llapack $(LDFLAGS)
	rm -rf tmp
	ln -s libtmglib.so.$(DEB_VERSION_UPSTREAM) libtmglib.so.$(SO)
	ln -s libtmglib.so.$(DEB_VERSION_UPSTREAM) libtmglib.so

	# Build liblapacke.so.*
	mkdir -p tmp
